<!-- <p>dashboard works!</p>
 <mwl-calendar-month-view [viewDate]="viewDate">
</mwl-calendar-month-view> -->
<!-- <mwl-calendar-week-view [viewDate]="viewDate">
</mwl-calendar-week-view> -->
<!-- <mwl-calendar-day-view [viewDate]="viewDate">
</mwl-calendar-day-view> -->
<div class="container-fluid float-end">
  <ul ngbNav #nav="ngbNav" [(activeId)]="active" class="nav-tabs">
    <li [ngbNavItem]="1">
      <a ngbNavLink>Calendar View</a>
      <ng-template ngbNavContent>
        <button type="button" class="btn btn-primary m-3" (click)="show()">
          Add Event
        </button>

        <div class="row">
          <div class="col">
            <div class="btn-group">
              <div
                class="btn btn-primary"
                mwlCalendarPreviousView
                [view]="view"
                [(viewDate)]="viewDate"
              >
                Previous
              </div>
              <div
                class="btn btn-outline-secondary"
                mwlCalendarToday
                [(viewDate)]="viewDate"
              >
                Today
              </div>
              <div
                class="btn btn-primary"
                mwlCalendarNextView
                [view]="view"
                [(viewDate)]="viewDate"
              >
                Next
              </div>
            </div>
          </div>
          <div class="col">
            <h1>{{ viewDate | calendarDate: view + "ViewTitle":"en" }}</h1>
          </div>

          <!-- <mwl-calendar-month-view [viewDate]="viewDate">
    </mwl-calendar-month-view>  -->
          <div class="col">
            <div class="btn-group float-end">
              <div
                class="btn btn-primary"
                (click)="setView(CalendarView.Month)"
                [class.active]="view === CalendarView.Month"
              >
                Month
              </div>
              <div
                class="btn btn-primary"
                (click)="setView(CalendarView.Week)"
                [class.active]="view === CalendarView.Week"
              >
                Week
              </div>
              <div
                class="btn btn-primary"
                (click)="setView(CalendarView.Day)"
                [class.active]="view === CalendarView.Day"
              >
                Day
              </div>
            </div>
          </div>
        </div>

        <div [ngSwitch]="view">
          <mwl-calendar-month-view
            (dayClicked)="dayClicked($event.day)"
            *ngSwitchCase="CalendarView.Month"
            [viewDate]="viewDate"
            [events]="events"
            [refresh]="refresh"
            [activeDayIsOpen]="activeDayIsOpen"
            (dayClicked)="dayClicked($event.day)"
            (eventClicked)="handleEvent('Clicked', $event.event)"
            (eventTimesChanged)="eventTimesChanged($event)"
          >
          </mwl-calendar-month-view>

          <mwl-calendar-week-view
            *ngSwitchCase="CalendarView.Week"
            [viewDate]="viewDate"
            [events]="events"
            [refresh]="refresh"
            (eventClicked)="handleEvent('Clicked', $event.event)"
            (eventTimesChanged)="eventTimesChanged($event)"
          >
          </mwl-calendar-week-view>

          <mwl-calendar-day-view
            *ngSwitchCase="CalendarView.Day"
            [viewDate]="viewDate"
            [events]="events"
            [refresh]="refresh"
            (eventClicked)="handleEvent('Clicked', $event.event)"
            (eventTimesChanged)="eventTimesChanged($event)"
          >
          </mwl-calendar-day-view>
        </div>
      </ng-template>
    </li>
    <li [ngbNavItem]="2">
      <a ngbNavLink>Tabular View</a>
      <ng-template ngbNavContent>
        <h1>
          List of events
        </h1>
        <div class="table-responsive">
          <table class="table table-bordered">
            <thead>
              <tr>
                <th>Title</th>
                <th>Description</th>
                <th>Start</th>
                <th>Starttime</th>
                <th>Endtime</th>
                <th>End</th>
                <th>Location</th>
                <th>Operation</th>
              </tr>
            </thead>
               
            <tbody>
              <tr *ngFor="let event of events">
                <td>{{event.title}}</td>
                <td>{{event.description}}</td>
                <td>{{event.start | date: 'short' }}</td>
                <td>{{event.starttime}}</td>
                <td>{{event.endtime}}</td>
                <td>{{event.end}}</td>
                <td>{{event.location}}</td>
                <td>
                  <button class="btn btn-danger" (click)="deleteEvent(event)">
                    Delete 
                  </button>
                </td>
            </tbody>
          </table>
        </div>
      </ng-template>
    </li>
  </ul>
  <div [ngbNavOutlet]="nav"></div>
  <pre>Active: {{ active }}</pre>
</div>

<!-- Creates the bootstrap modal where the image will appear -->
<div [style.display]="showModal ? 'block' : 'none'" class="modal">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title">Add event</h1>
      </div>
      <div class="modal-body">
        <form [formGroup]="registerForm" (ngSubmit)="onSubmit()">
          <div class="form-group">
            <label>Title</label>
            <input
              type="text"
              formControlName="title"
              class="form-control"
              [ngClass]="{ 'is-invalid': submitted && f.title.errors }"
            />
            <div *ngIf="submitted && f.title.errors" class="invalid-feedback">
              <div *ngIf="f.title.errors.required">title is required</div>
              <div *ngIf="f.title.errors.minlength">
                title must be at least 6 characters
              </div>
            </div>
          </div>
          <div class="form-group">
            <label> Description</label>
            <textarea
              type="text"
              formControlName="description"
              class="form-control"
              rows="3"
              [ngClass]="{ 'is-invalid': submitted && f.description.errors }"
            ></textarea>
            <div
              *ngIf="submitted && f.description.errors"
              class="invalid-feedback"
            >
              <div *ngIf="f.description.errors.required">
                Description is required
              </div>
              <div *ngIf="f.description.errors.minlength">
                Description must be at least 20 characters
              </div>
            </div>
          </div>
          <div class="form-group">
            <div class="row">
              <label>Start Date/Time</label>
              <div class="col">
                <input
                  type="text"
                  placeholder="start date"
                  formControlName="start"
                  class="form-control"
                  [ngClass]="{ 'is-invalid': submitted && f.start.errors }"
                />
                <div
                  *ngIf="submitted && f.start.errors"
                  class="invalid-feedback"
                >
                  <div *ngIf="f.start.errors.required">
                    startdate is required
                  </div>
                </div>
              </div>
              <div class="col">
                <input
                  type="text"
                  placeholder="start time"
                  formControlName="starttime"
                  class="form-control"
                  [ngClass]="{ 'is-invalid': submitted && f.starttime.errors }"
                />
                <div
                  *ngIf="submitted && f.starttime.errors"
                  class="invalid-feedback"
                >
                  <div *ngIf="f.starttime.errors.required">
                    starttime is required
                  </div>
                </div>
              </div>
            </div>
          </div>

          <div class="form-group">
            <div class="row">
              <label>End Date/Time</label>
              <div class="col">
                <input
                  type="text"
                  placeholder="End date"
                  formControlName="end"
                  class="form-control"
                  [ngClass]="{ 'is-invalid': submitted && f.end.errors }"
                />

                <div *ngIf="submitted && f.end.errors" class="invalid-feedback">
                  <div *ngIf="f.end.errors.required">enddate is required</div>
                </div>
              </div>
              <div class="col">
                <input
                  type="text"
                  placeholder="End time"
                  formControlName="endtime"
                  class="form-control"
                  [ngClass]="{ 'is-invalid': submitted && f.endtime.errors }"
                />
                <div
                  *ngIf="submitted && f.endtime.errors"
                  class="invalid-feedback"
                >
                  <div *ngIf="f.endtime.errors.required">
                    endtime is required
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="form-group">
            <label>Location</label>
            <input
              type="text"
              formControlName="location"
              class="form-control"
              [ngClass]="{ 'is-invalid': submitted && f.location.errors }"
            />
            <div
              *ngIf="submitted && f.location.errors"
              class="invalid-feedback"
            >
              <div *ngIf="f.location.errors.required">Location is required</div>
              <div *ngIf="f.description.errors.minlength">
                Location must be at least 2 characters
              </div>
            </div>
          </div>

          <button type="submit" class="btn btn-primary">Submit</button>
        </form>
      </div>
    </div>
  </div>
</div>

<ng-template #modalContent let-close="close">
  <div class="modal-header">
    <h5 class="modal-title">Event action occurred</h5>
    <button type="button" class="close" (click)="close()">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div>
      Action:
      <pre>{{ modalData?.action }}</pre>
    </div>
    <div>
      Event:
      <pre>{{ modalData?.event | json }}</pre>
    </div>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-secondary" (click)="close()">
      OK
    </button>
  </div>
</ng-template>
